//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E89C5D702F5.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E89C5D702F5.cm

//## begin module%3E89C5D702F5.cp preserve=no
//## end module%3E89C5D702F5.cp

//## Module: FakeDataInputRecord%3E89C5D702F5; Package body
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/FakeDataInputRecord.cxx

//## begin module%3E89C5D702F5.additionalIncludes preserve=no
//## end module%3E89C5D702F5.additionalIncludes

//## begin module%3E89C5D702F5.includes preserve=yes
#include <XSstreams.h>
#include <iostream>
//## end module%3E89C5D702F5.includes

// FakeDataInputRecord
#include <XSModel/Data/FakeDataInputRecord.h>
//## begin module%3E89C5D702F5.declarations preserve=no
//## end module%3E89C5D702F5.declarations

//## begin module%3E89C5D702F5.additionalDeclarations preserve=yes
//## end module%3E89C5D702F5.additionalDeclarations


// Class FakeDataInputRecord 

FakeDataInputRecord::FakeDataInputRecord (size_t nSpec)
  //## begin FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.hasinit preserve=yes
  : DataInputRecord(""),
    m_backgndFile(""),
    m_useCountingStat(false),
    m_isType2(false),
    m_exposureTime(.0),
    m_correctionNorm(.0),
    m_enteredNone(false),
    m_numSourcesForSpectra(1),
    m_origRowNums(),
    m_inputCorrFiles(std::vector<BackLocator>(nSpec)),   
    m_inputBackgrounds(std::vector<BackLocator>(nSpec)),
    m_inputResponses(std::vector<Detectors>(nSpec)),
    m_inputArfs(std::vector<Arfs>(nSpec))
  //## end FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.hasinit
  //## begin FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.initialization preserve=yes
  //## end FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.initialization
{
  //## begin FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.body preserve=yes
   IntegerArray tmp(nSpec);
   setSpectrumNumber(tmp);
   setSpectrumRange(tmp);
  //## end FakeDataInputRecord::FakeDataInputRecord%3E95DDF200C1.body
}


FakeDataInputRecord::~FakeDataInputRecord()
{
  //## begin FakeDataInputRecord::~FakeDataInputRecord%3E89C781030C_dest.body preserve=yes
  //## end FakeDataInputRecord::~FakeDataInputRecord%3E89C781030C_dest.body
}



//## Other Operations (implementation)
void FakeDataInputRecord::printDiagnostics () const
{
  //## begin FakeDataInputRecord::printDiagnostics%3EC538C10397.body preserve=yes
  tcout << "\nFake file name: " << fileName();
  tcout << "\nBased on original data?: " << (data() ? "yes" : "no");
  tcout << "\nType: " << (m_isType2 ? 2 : 1);
  tcout << "\nData group number: " << groupNumber();
  
  size_t sz = spectrumNumber().size();
  tcout << "\nSpectrum numbers: ";
  for (size_t i=0; i<sz; ++i)
  {
     tcout << spectrumNumber(i) << " ";
  }
  tcout << "\nRow numbers: ";
  for (size_t i=0; i<sz; ++i)
  {
     tcout << spectrumRange(i) << " ";
  }
  tcout << "\nOutput background file: " << m_backgndFile;
  tcout << "\nInput responses: "<<std::endl;
  sz = m_inputResponses.size();
  for (size_t i=0; i<sz; ++i)
  {
     const Detectors& dets = inputResponses(i);     
     for (size_t j=0; j<dets.size(); ++j)
        tcout <<"   "<<dets[j].first<<","<<dets[j].second; 
     tcout <<std::endl;
  }
  tcout << "\nInput arfs: "<<std::endl;
  for (size_t i=0; i<sz; ++i)
  {
     const Arfs& arfs = inputArfs(i);
     for (size_t j=0; j<arfs.size(); ++j)
        tcout <<"  "<<arfs[j].first.first<<","<<arfs[j].first.second<<","<<arfs[j].second;
     tcout <<std::endl;
  }
  tcout << "\nInput backgrounds: ";
  for (size_t i=0; i<sz; ++i)
  {
     tcout <<"\n  " << m_inputBackgrounds[i].first << "  " << m_inputBackgrounds[i].second;
  }
  tcout << "\nInput corr files: ";
  for (size_t i=0; i<sz; ++i)
  {
     tcout <<"\n  " << m_inputCorrFiles[i].first << "  " << m_inputCorrFiles[i].second;
  }
  tcout << "\nExposure time: " << m_exposureTime;
  tcout << "\nCorrection norm: " << m_correctionNorm;
  tcout << "\nUse counting stat: " << m_useCountingStat;
  tcout << "\n" <<std::endl;
  //## end FakeDataInputRecord::printDiagnostics%3EC538C10397.body
}

// Additional Declarations
  //## begin FakeDataInputRecord%3E89C781030C.declarations preserve=yes
  //## end FakeDataInputRecord%3E89C781030C.declarations

//## begin module%3E89C5D702F5.epilog preserve=yes
//## end module%3E89C5D702F5.epilog
